extends CharacterBody2D

@onready var stm := $StateMachine

@onready var bounce := $StateMachine/Bounce
@onready var fly := $StateMachine/Fly

# final time = time +/- (random(-1, 1) * variation)
@export var bounce_time: float
@export var bounce_time_variation: float
@export var fly_time: float
@export var fly_time_variation: float

var state_time_tmp := 0.0

@export var bounce_angle: float

var rng := RandomNumberGenerator.new()

func current_state():
	return stm.state

func get_new_dir():
	return Vector2.from_angle(rng.randf() * PI*2)

func get_new_bounce_dir():
	if rng.randi_range(0, 1) == 1:
		return Vector2.from_angle((-PI/2) + bounce_angle)
	else:
		return Vector2.from_angle((-PI/2) + (-bounce_angle))

func _ready():
	state_time_tmp = fly_time + rng.randf() * fly_time_variation
	current_state().enter(get_new_dir())

func _process(delta):
	if state_time_tmp <= 0:
		if current_state() in [bounce]:
			stm.transition(fly, get_new_dir())
			state_time_tmp = fly_time + rng.randf() * fly_time_variation
		elif current_state() in [fly]:
			stm.transition(bounce, get_new_bounce_dir())
			state_time_tmp = bounce_time + rng.randf() * bounce_time_variation
	else:
		state_time_tmp -= delta
	
	current_state().update(delta)
