extends Node

# Flies in direction and "bounces off walls"

@onready var actor = get_parent().get_parent()

@export var speed: float
@export var speed_variation: float

var speed_tmp: float

var rng := RandomNumberGenerator.new()

func enter(dir):
	speed_tmp = speed + rng.randf() * speed_variation
	actor.velocity = dir * speed_tmp

func update(delta):
	var collision_info = actor.move_and_collide(actor.velocity * delta)
	if collision_info:
		actor.velocity = actor.velocity.bounce(collision_info.get_normal())

