# Place available states under this node.statema
# Provides the mechanism for switching states.
@icon("res://state_machine/think.png")
extends Node
class_name StateMachine

@export var initial_state: NodePath
@export var dont_enter_at_init: bool
var state: Node  # Current state

# Set by owner
var state_debug_stat = null
var state_debug_log = null

func _ready():
	state = get_node(initial_state)
	if !dont_enter_at_init:
		state.enter({})

func transition(new_state, args = {}):
	Debug.maybe_put_stat(state_debug_stat, new_state.name)
	Debug.maybe_put_log(state_debug_log, "transitioned to: " + new_state.name)
	state = new_state
	new_state.enter(args)

func _physics_process(delta):
	state.update(delta)
