# Sliding down a wall
extends Node

@onready var actor = get_parent().get_parent()

## Acceleration towards slide_speed
@export var slide_accel: float
## The max speed at which the character slides down
@export var slide_speed: float
## The velocity at which the character launches when doing a walljump
@export var x_launch: float
## The stats associated with a walljump
@export var wall_jump_stats: JumpStats

func enter(_args):
	pass

func update(delta):
	actor.velocity.y = move_toward(actor.velocity.y, slide_speed, delta * slide_accel)
	actor.move_and_slide()

# Called by owner
func walljump():
	if actor.looking_right: actor.velocity.x -= x_launch
	else:                   actor.velocity.x += x_launch
	actor.velocity.y = - wall_jump_stats.initial_velocity
	return wall_jump_stats
