extends Area2D
## Hurtbox with iframes, emits "hurt".
## Does not check to be hurt, expects an assailant to call "hit".

signal hurt(data)

@export var active := true:
	set(v):
		active = v
		process_mode = PROCESS_MODE_INHERIT if active else PROCESS_MODE_DISABLED

@export var iframes := 0.5
var iframes_tmp: float
var iframes_active := false

func _process(delta):
	if iframes_active:
		if iframes_tmp <= 0:
			iframes_active = false
		else:
			iframes_tmp -= delta

## Call this from anywhare that wants to hurt this hurtbox
func hit(data):
	if !iframes_active:
		hurt.emit(data)
		iframes_active = true
		iframes_tmp = iframes
		
		# TODO: make it so that you can specify the hit sound, hurt-box could
		# provide more information about the interaction (what kind of material it is).
		if has_node("HurtSound"):
			get_node("HurtSound").play()
