extends Resource
class_name JumpStats

## The acceleration upwards (y) depending on the time after launch (x).
## This curve is applied when still holding jump.
@export
var rise_curve: Curve

@export
var initial_velocity: float

## Same as rise_curve but when jump is released.
@export
var released_curve: Curve

func _init(p_rise_curve = null, p_initial_velocity = 0.0, p_released_curve = null):
	rise_curve = p_rise_curve
	initial_velocity = p_initial_velocity
	released_curve = p_released_curve

# Calculate new y-velocity
func jump(yvel: float, time: float, released_jump: bool, delta: float, stat_key = null):
	if released_jump:
		Debug.maybe_put_stat(stat_key, "released jump")
		return yvel - released_curve.sample(time) * delta
	else:
		# Rising when holding the button
		Debug.maybe_put_stat(stat_key, "holding jump")
		return yvel - rise_curve.sample(time) * delta
